/******************************************************************************
 *	chdraw.c:	`[g̕`揈֐
 ******************************************************************************
 *	Workroom SX-68K Sample Program Copyright 1994 SHARP
 */
#include <stdio.h>
#include <math.h>
#include <sxgraph.h>		/* Otn}l[W𗘗pƂɕKv */
#include <dialog.h>		/* _CAO}𗘗pƂɕKv	*/
#include "chart.h"		/* ̃vOŗL̃wb_t@C	*/

static Rect rcoval = { 50, 50 + GRPY, 50 + 200, 50 + GRPY + 200 };

/******************************************************************************
 *	drawCircle():	~Ot̕`
 ******************************************************************************
 *	:	ComVal *pcv	ʕϐւ̃|C^
 */
void drawCircle(ComVal *pcv)
{
	int i, r;			/* ~Ot̒S_	*/
	int oldpm, oldfc, oldbc, oldfm, oldff;
	Point pt1, pt2;
	Rect rc;			/* N^O		*/
	char str[32];			/* i[p		*/

	static Rect OgiRect = { 0, 0, 40, 40 };

	/* `摮ݒ */
	oldpm = GMPenMode(G_PSET);
	oldfc = GMForeColor(GC_BLACK);
	oldbc = GMBackColor(GC_WHITE);
	oldfm = GMFontMode(G_PSET);

	/* ^Cg */
	oldff = GMFontFace(G_BOLD | G_ULINE);
	drawStrZ("~ O  t (P:% )", LONGWORD(15, GRPY + 10));
	GMFontFace(oldff);

	/* z\ */
	sprintf(str, "  v  %8d ~\0", pcv->sum[pcv->month - 1]);
	drawStrZ(str, LONGWORD(OGIX, GRPY + 10));

	/* eږ̕\ */
	r = OgiRect.d.right / 2;
	for (i = 0; i < 7; i++) {
		rc = OgiRect;
		GMSlideRect(&rc, LONGWORD(OGIX, i * 30 + 30 + GRPY));
		GMForeColor(gColor[i]);
		GMFillArc(&rc, CRCLSTR, CRCLEND);

		/* ^̉ */
		GMForeColor(GC_BLACK);
		GMFrameArc(&rc, CRCLSTR, CRCLEND);
		pt1.p.x = (rc.d.right + rc.d.left) / 2 - 1;
		pt1.p.y = (rc.d.bottom + rc.d.top) / 2 - 1;
		pt2.x_y = angleToPos(CRCLSTR, r, r);
		pt2.p.x += pt1.p.x;
		pt2.p.y += pt1.p.y;
		GMMove(pt2.x_y);
		GMLine(pt1.x_y);
		pt2.x_y = angleToPos(CRCLEND, r, r);
		pt2.p.x += pt1.p.x;
		pt2.p.y += pt1.p.y + 1;
		GMLine(pt2.x_y);
		drawStrZ(crclTtl[i], LONGWORD(OGIX + 55, rc.d.top + 4));
	}
	/* f[^\s\̂Ƃ */
	if (pcv->sum[pcv->month - 1] == 0) {
		GMForeColor(GC_BLACK);
		/* ~ʕ`惌N^O */
		GMFrameOval(&rcoval);
		GMPenMode(oldpm);
		GMForeColor(oldfc);
		GMBackColor(oldbc);
		GMFontMode(oldfm);
		return;
	}
	/* ~Ot\ */
	drawArc(pcv);

	/* `摮ftHg̒lɂ */
	GMPenMode(oldpm);
	GMForeColor(oldfc);
	GMBackColor(oldbc);
	GMFontMode(oldfm);
}

/******************************************************************************
 *	drawArc():	~Ot̕`
 ******************************************************************************
 *	:	ComVal *pcv	ʕϐւ̃|C^
 */
void drawArc(ComVal *pcv)
{
	int i, scale, op;
	int lastPM, lastFC, lastBC, lastFM;
	int deg, dw, rx, ry;
	int rate[7], drpt[2][7];
	char str[16];
	Point pt;

	calcRate(pcv, rate);

	/* 360x / zv = P~̊px߂ */
	scale = KETA1 * 360 / pcv->sum[pcv->month - 1];
	op = 450;
	for (i = 0; i < 7; i++) {
		/* `Ipx */
		drpt[1][i] = op;
		/* `Jnpx */
		drpt[0][i] = op - ((pcv->money[pcv->month - 1][i] * scale + KETA1 / 2) / KETA1);
		/* ̕`Jnʒû߂ɑҔ */
		op = drpt[0][i];
	}

	/* `摮ݒ */
	lastFC = GMForeColor(GC_WHITE);
	lastBC = GMBackColor(GC_WHITE);
	lastPM = GMPenMode(G_PSET);
	lastFM = GMFontMode(G_PSET);

	/* `悷 */
	for (i = 0; i < 7; i++)
		/* startend͉~`Ă܂̂ł̏ꍇ͕`悵Ȃ */
		if (drpt[0][i] != drpt[1][i]) {
			/* ^̕` */
			GMForeColor(gColor[i]);
			GMFillArc(&rcoval, drpt[0][i], drpt[1][i]);
		}
	GMForeColor(GC_BLACK);
	GMFrameOval(&rcoval);

	for (i = 0; i < 7; i++) {
		dw = drpt[1][i] - drpt[0][i];
		if (rate[i] != 0) {
			/* OłȂꍇ */
			deg = dw / 2 + drpt[0][i];
			GMForeColor(GC_BLACK);
			GMFontMode(G_PSET);
			if (dw < 20) {
				/* pxQOxȉ̏ꍇ */
				GMBackColor(GC_WHITE);
				rx = 18;
				ry = 12;
			} else {
				/* pxQOxȏ̏ꍇ */
				GMBackColor(gColor[i]);
				rx = -18;
				ry = -18;
			}
			/* px~̈ʒu߂ */
			sprintf(str, "%.1f\0", (double) rate[i] / 10.0);
			pt.x_y = angleToPos(deg, RADIUS + rx, RADIUS + ry);
			pt.p.x += CENTERX;
			pt.p.y += CENTERY;
			/* (x,y)𒆐Sɕ` */
			drawStrM(str, pt.x_y);
		}
	}
	GMForeColor(lastFC);
	GMBackColor(lastBC);
	GMPenMode(lastPM);
	GMFontMode(lastFM);
}

/******************************************************************************
 *	calcRate():	w茎̊eڂ̃p[Ze[WvZ
 ******************************************************************************
 *	:	ComVal *pcv	ʕϐւ̃|C^
 *		int *rate	p[Ze[W̒li[|C^
 */
void calcRate(ComVal *pcv, int *rate)
{
	int i, scale;

	/* 100.0% / zv = P~̃p[Ze[W߂ */
	scale = KETA2 * 1000 / pcv->sum[pcv->month - 1];
	for (i = 0; i < 7; i++)
		rate[i] = (pcv->money[pcv->month - 1][i] * scale + KETA2 / 2) / KETA2;
}

/******************************************************************************
 *	angleToPos():	O`RUOx̒l~̍Wɕϊ
 ******************************************************************************
 *	:	int deg		px(0`360)
 *		int rx		~̔a(x)
 *		int ry		   V   (y)
 *	߂l:	LPoint
 */
LPoint angleToPos(int deg, int rx, int ry)
{
	double dx, dy, rd;
	Point pt;

	rd = (double) deg / (360.0 / (PI * 2.0));
	dx = cos(rd) * rx;
	dy = sin(rd) * ry;
	/* ɂȂ߁Aľܓ */
	pt.p.x =  (short)(dx + 0.5 * (dx / fabs(dx)));
	pt.p.y = -(short)(dy + 0.5 * (dy / fabs(dy)));
	return pt.x_y;
}

/******************************************************************************
 *	drawRadar():	[_[`[g̕`
 ******************************************************************************
 *	:	ComVal *pcv	ʕϐւ̃|C^
 */
void drawRadar(ComVal *pcv)
{
	int oldpm, oldfc, oldfm, oldff;
	int i, j;			/* [vJE^		*/
	int max;			/* ڐ̍ől		*/
	int dMax;			/* f[^̍ől		*/
	int val[7];			/* ep[^̑傫ij	*/
	int temp;			/* [N			*/
	int len;			/* ڐ̒		*/
	double ang;			/* px			*/
	double th;			/* ]px			*/
	double vx[7], vy[7];		/* [_[`[gẽxNg */
	double nx, ny;			/* ̖@xNg		*/
	char str[32];			/* \i[p		*/
	Point pt, pt2, vpt[7];
	LPoint oldlps;

	/* f[^̍őldMaxƂ */
	dMax = 0;
	for (i = 0; i < 7; i++) {
		temp = pcv->money[pcv->month - 1][i];
		if (dMax < temp)
			dMax = temp;
	}

	/* ڐ̍őľvZ */
	for (max = 10; ; max *= 10)
		/* ŽʂPɂȂ܂ */
		if (dMax / max < 10)
			break;
	/* ڐ̍ől͂T݂̒lɂ */
	for (i = 5; i <= 10; i += 5) {
		temp = i * max;
		/* ŽʂO */
		if (dMax / temp == 0) {
			max = temp;
			break;
		}
	}

	/* ef[^max̉p[ZgvZ */
	/* i_ȉľܓj */
	for (i = 0; i < 7; i++)
		val[i] = (int)(100.0 * ((double) pcv->money[pcv->month - 1][i] / (double) max) + 0.5);

	/* ẽxNǧvZ */
	ang = 0.897597901;		/* 360/7xradianɕϊ */
	for (i = 0; i < 7; i++) {
		/* ]p */
		th = ang * (double) i;
		/* ang(rad)Â](cw) */
		vx[i] = sin(th);
		vy[i] = -cos(th);
	}

	/* `摮ݒ */
	oldpm = GMPenMode(G_PSET);
	oldfc = GMForeColor(GC_BLACK);
	oldfm = GMFontMode(G_PSET);

	/* ^Cg */
	oldff = GMFontFace(G_BOLD | G_ULINE);
	drawStrZ(" [ _ [ `  [ g (P:~)", LONGWORD(15, GRPY + 10));
	GMFontFace(oldff);
	/* z\ */
	sprintf(str, "  v  %8d ~\0", pcv->sum[pcv->month - 1]);
	drawStrZ(str, LONGWORD(270, GRPY + 10));

	/* [_[`[g̎V{̕` */
	for (i = 0; i < 7; i++) {
		vpt[i].p.x = (int)(100.0 * vx[i]) + RADERSTX;
		vpt[i].p.y = (int)(100.0 * vy[i]) + RADERSTY;
		GMMove(LONGWORD(RADERSTX, RADERSTY)); /* yړ	*/
		GMLine(LONGWORD(vpt[i].p.x, vpt[i].p.y)); /* `悷 */
		/* xNg̖@xNg */
		nx = vy[i];
		ny = -vx[i];
		/* ڐ̕` */
		for (j = 1; j < 11; j++) {
			/* T̔{̖ڐ͒T^̑͂Q */
			len = (j == 5 || j == 10) ? 5 : 2;
			/* yړ */
			GMMove(LONGWORD(RADERSTX + (int)(10 * j * vx[i] + len * nx), RADERSTY + (int)(10 * j * vy[i] + len * ny)));
			/* `悷 */
			GMLine(LONGWORD(RADERSTX + (int)(10 * j * vx[i] - len * nx), RADERSTY + (int)(10 * j * vy[i] - len * ny)));
		}
	}
	/*  */
	drawStrZ("Z", LONGWORD(RADERSTX - 12, RADERSTY - 120));
	vpt[1].p.x += 12;
	vpt[1].p.y -= 12;
	drawStrZ("ME", vpt[1].x_y);
	vpt[2].p.x += 12;
	drawStrZ("H", vpt[2].x_y);
	vpt[3].p.x -= 12;
	vpt[3].p.y += 6;
	drawStrZ("핞", vpt[3].x_y);
	vpt[4].p.x -= 18;
	vpt[4].p.y += 6;
	drawStrZ("~", vpt[4].x_y);
	vpt[5].p.x -= 72;
	drawStrZ("{Ey", vpt[5].x_y);
	vpt[6].p.x -= 36;
	vpt[6].p.y -= 12;
	drawStrZ("G", vpt[6].x_y);

	/* WARNING : dMax O */
	if (dMax == 0)
		return;

	/* f[^̕` */
	/* PԖڂ̃f[^n_Ƃ */
	pt.p.x = (int)(val[0] * vx[0]) + RADERSTX;
	pt.p.y = (int)(val[0] * vy[0]) + RADERSTY;
	GMMove(pt.x_y);
	/*  */
	oldlps = GMPenSize(LONGWORD(2, 2));
	GMForeColor(GC_RED);
	for (i = 1; i < 7; i++) {
		pt2.p.x = (int)(val[i] * vx[i]) + RADERSTX;
		pt2.p.y = (int)(val[i] * vy[i]) + RADERSTY;
		GMLine(pt2.x_y);
	}
	/* Ō͎n_ɂĕ */
	GMLine(pt.x_y);
	GMPenSize(oldlps);

	/* ڐ̒l */
	/* max/2 */
	GMForeColor(GC_BLACK);
	sprintf(str, "%8d\0", max / 2);
	drawStrZ(str, LONGWORD(RADERSTX - 54, RADERSTY - 10 * 5 - 6));
	/* max */
	sprintf(str, "%8d\0", max);
	drawStrZ(str, LONGWORD(RADERSTX - 54, RADERSTY - 10 * 10 - 6));

	/* `摮ftHg̒lɂ */
	GMPenMode(oldpm);
	GMForeColor(oldfc);
	GMFontMode(oldfm);
}

/******************************************************************************
 *	drawBar():	_Ot̕`
 ******************************************************************************
 *	:	ComVal *pcv	ʕϐւ̃|C^
 */
void drawBar(ComVal *pcv)
{
	int i, j;			/* [vJE^	*/
	int kt, mt, st;
	int len, keta, dot, measmax, meas, dMax;
	int oldpm, oldfc, oldfm, oldff;
	int mon[4];
	Point pt;
	Rect rc;			/* N^O		*/
	char str[32];			/* \p		*/

	/* \錎ݒ */
	mon[3] = pcv->month;		/* 		*/
	mon[2] = lastMonth(mon[3]);	/* PO	*/
	mon[1] = lastMonth(mon[2]);	/* QO	*/
	mon[0] = lastMonth(mon[1]);	/* RO	*/

	/* `摮ݒ */
	oldpm = GMPenMode(G_PSET);
	oldfc = GMForeColor(GC_BLACK);
	oldfm = GMFontMode(G_PSET);

	/* ^Cg */
	oldff = GMFontFace(G_BOLD | G_ULINE);
	drawStrZ("_ O  t (P:~)", LONGWORD(15, GRPY + 10));
	GMFontFace(oldff);
	/* z\ */
	sprintf(str, "  v  %8d ~\0", pcv->sum[pcv->month - 1]);
	drawStrZ(str, LONGWORD(270, GRPY + 10));

	/* Ac` */
	GMMove(LONGWORD(BARSTX, BARSTY)); /* yړ		*/
	GMLine(LONGWORD(BARSTX + BARLEN + 20, BARSTY)); /* `悷 */
	GMMove(LONGWORD(BARSTX, BARSTY)); /* yړ		*/
	GMLine(LONGWORD(BARSTX, BARSTY + 160)); /* `悷	*/

	/* f[^̍őldMax߂ */
	/*  */
	dMax = 0;
	for (i = 0; i < 4; i++)
		if (dMax < pcv->sum[mon[i] - 1])
			dMax = pcv->sum[mon[i] - 1];

	/* őľ߂(𕶎ŃJEg) */
	kt = sprintf(str, "%d", dMax);
	keta = (int) pow(10.0, (double)(kt - 1));	/* 10^kt */
	/* ڐ̍ől */
	measmax = ((dMax / keta) + 1) * keta;
	meas = keta / 10;
	/* P~̃hbg߂ */
	dot = (BARSCL * BARLEN) / measmax;

	/* őľP̏ꍇ */
	if (kt == 1) {
		kt = 2;
		measmax = 10;
		meas = 1;
		dot = (BARSCL * BARLEN) / measmax;
	}
	/* ڐ̐l̒Pʂ𒲐 */
	if (kt > 2) {
		mt = 2;
		st = kt - mt - 1;
	} else {
		st = 0;
		mt = kt - 1;
	}
	/* ڐƁAPʂ̕\ */
	for (i = 0; i <= measmax / meas; i++) {
		if ((i % 5) == 0)
			/* ڐ̔ԍT^POiނƂ */
			len = ((i % 10) != 0) ? 3 : 5;
		else
			/* ڐ̕ROȉ^̖̑ڐԍ̏ꍇ */
			len = (measmax / meas <= 30) ? 2 : 0;
		/* ڐ̕`Ɛl̕\ */
		j = (dot * meas * i + BARSCL / 2) / BARSCL;
		if (len == 5) {
			sprintf(str, "%d\0", i * (int) pow(10.0, (double)(mt - 1)));
			drawStrM(str, LONGWORD(BARSTX + j, BARSTY - len - 6));
		}
		GMMove(LONGWORD(BARSTX + j, BARSTY + len)); /* yړ */
		GMLine(LONGWORD(BARSTX + j, BARSTY - len)); /* `悷 */
	}
	/* Rȏ̐l̏ꍇ */
	if (st != 0) {
		/* ڐ̐l̃XP[\ */
		sprintf(str, "(x%d)\0", (int) pow(10.0, (double) st));
		drawStrZ(str, LONGWORD(BARSTX + BARLEN + 18, BARSTY - 11));
	}
	/* ̕\ */
	for (j = 0; j < 4; j++) {
		sprintf(str, "%2d\0", mon[j]);
		drawStrZ(str, LONGWORD(BARSTX - 24 - 3, BARSTY + 14 + j * BAROFF));
	}
	/* _Ot̕` */
	for (j = 0; j < 4; j++) {
		rc.d.right = BARSTX;
		rc.d.top = BARSTY + 8 + j * BAROFF;
		for (i = 0; i < 7; i++) {
			rc.d.left = rc.d.right;
			rc.d.right = rc.d.left + (dot * pcv->money[mon[j] - 1][i] + BARSCL / 2) / BARSCL;
			rc.d.bottom = rc.d.top + 25;
			GMForeColor(gColor[i]);
			GMFillRect(&rc);
			GMForeColor(GC_BLACK);
			rc.d.right++;
			/* ̕` */
			GMFrameRect(&rc);
			rc.d.right--;
		}
	}
	GMForeColor(GC_BLACK);
	/* z\ */
	for (j = 0; j < 4; j++) {
		sprintf(str, "%8d ~\0", pcv->sum[mon[j] - 1]);
		drawStrZ(str, LONGWORD(BARGX, BARSTY + 14 + j * BAROFF));
	}

	/* ږ\ */
	/* _OtɑΉF̕tN^Oƕŕ\ */
	for (i = 0; i < 7; i++) {
		rc.d.left = BARTX + (i / 2) * 90;
		rc.d.top = BARTY + (i % 2) * 20;
		rc.d.right = rc.d.left + 10;
		rc.d.bottom = rc.d.top + 10;
		GMForeColor(gColor[i]);
		GMFillRect(&rc);
		GMForeColor(GC_BLACK);
		GMFrameRect(&rc);
		pt.p.x = rc.d.left + 10 + 5;
		pt.p.y = rc.d.top;
		drawStrZ(crclTtl[i], pt.x_y);
	}
	/* `摮ftHg̒lɂǂ */
	GMPenMode(oldpm);
	GMForeColor(oldfc);
	GMFontMode(oldfm);
}

/******************************************************************************
 *	drawLine():	܂Ot̕`
 ******************************************************************************
 *	:	ComVal *pcv	ʕϐւ̃|C^
 */
void drawLine(ComVal *pcv)
{
	int len, i, j;
	int oldpm, oldfc, oldfm, oldff;
	int mt, st;
	int kt, keta, dot, measmax, meas, dMax;
	int mon[4];
	Point pt;
	LPoint oldlps;
	Rect rc;
	char str[32];

	/*  */
	mon[3] = pcv->month;
	mon[2] = lastMonth(mon[3]);
	mon[1] = lastMonth(mon[2]);
	mon[0] = lastMonth(mon[1]);

	/* f[^̍őldMax߂ */
	dMax = 0;
	for (j = 0; j < 4; j++)
		for (i = 0; i < 7; i++)
			if (dMax < pcv->money[mon[j] - 1][i])
				dMax = pcv->money[mon[j] - 1][i];

	/* őľ߂(𕶎ŃJEg) */
	kt = sprintf(str, "%d", dMax);
	keta = pow(10.0, (double)(kt - 1)); /* 10^kt */
	/* ڐ̍ől */
	measmax = ((dMax / keta) + 1) * keta;
	meas = keta / 10;
	/* P~̃hbg߂ */
	dot = (LINESCL * LINEVL) / measmax;

	/* őľP̏ꍇ */
	if (kt == 1) {
		kt = 2;
		measmax = 10;
		meas = 1;
		dot = (LINESCL * LINEVL) / measmax;
	}
	/* ڐ̐l̒Pʂ𒲐 */
	if (kt > 2) {
		mt = 2;
		st = kt - mt - 1;
	} else {
		st = 0;
		mt = kt - 1;
	}

	/* `摮ݒ */
	oldpm = GMPenMode(G_PSET);
	oldfc = GMForeColor(GC_BLACK);
	oldfm = GMFontMode(G_PSET);
	/* ^Cg */
	oldff = GMFontFace(G_BOLD | G_ULINE);
	drawStrZ("   O  t (P:~)", LONGWORD(15, GRPY + 10));
	GMFontFace(oldff);
	/* z\ */
	sprintf(str, "  v  %8d ~\0", pcv->sum[pcv->month - 1]);
	drawStrZ(str, LONGWORD(270, GRPY + 10));

	/* ږ\ */
	/* ܂OtɑΉF̕tƕŕ\ */
	for (i = 0; i < 7; i++) {
		rc.d.left = LINETX + (i / 2) * 90;
		rc.d.top = LINETY + (i % 2) * 15 + 5;
		rc.d.right = rc.d.left + 10;
		rc.d.bottom = rc.d.top + 3;
		GMForeColor(gColor[i]);
		GMFillRect(&rc);
		GMForeColor(GC_BLACK);
		pt.p.x = rc.d.left + 15;
		pt.p.y = rc.d.top - 5;
		drawStrZ(crclTtl[i], pt.x_y);
	}
	/* ڐ莲 */
	GMForeColor(GC_BLACK);
	/* cA\ */
	/* ͂Thbgɂ炷if[^łOՂ悤Ɂj */
	GMMove(LONGWORD(LINESTX, LINESTY + 5)); /* yړ	*/
	GMLine(LONGWORD(LINESTX + LINEHL, LINESTY + 5)); /* `悷 */
	GMMove(LONGWORD(LINESTX, LINESTY + 5)); /* yړ	*/
	GMLine(LONGWORD(LINESTX, LINESTY - LINEVL - 5)); /* `悷 */

	/* z̖ڐƁAPʂ̕\ */
	for (i = 0; i <= measmax / meas; i++) {
		if ((i % 5) == 0)
			/* ڐ̔ԍT^POiނƂ */
			len = ((i % 10) != 0) ? 3 : 5;
		else
			/* ڐ̕ROȉ^̖̑ڐԍ̏ꍇ */
			len = (measmax / meas <= 30) ? 2 : 0;
		/* ڐ̕`Ɛl̕\ */
		j = (dot * meas * i + LINESCL / 2) / LINESCL;
		if (len == 5) {
			sprintf(str, "%4d\0", i * (int) pow(10.0, (double)(mt - 1)));
			drawStrZ(str, LONGWORD(LINESTX - 5 - 26, LINESTY - j - 6));
		}
		/* yړ */
		GMMove(LONGWORD(LINESTX - len, LINESTY - j));
		/* `悷 */
		GMLine(LONGWORD(LINESTX + len, LINESTY - j));
	}
	/* Rȏ̐l̏ꍇ */
	if (st != 0) {
		/* ڐ̐l̃XP[\ */
		j = sprintf(str, "(x%d)\0", (int) pow(10.0, (double) st));
		drawStrZ(str, LONGWORD(LINESTX - j * 6 - 2, LINESTY - LINEVL - 18));
	}

	/* \ */
	for (j = 0; j < 4; j++) {
		/* yړ */
		GMMove(LONGWORD(LINESTX + 30 + j * LINEOFF, LINESTY));
		/* `悷 */
		GMLine(LONGWORD(LINESTX + 30 + j * LINEOFF, LINESTY + 5 + 5));
		sprintf(str, "%2d\0", mon[j]);
		drawStrZ(str, LONGWORD(LINESTX + 30 + j * LINEOFF - 12, LINESTY + 5 + 5 - 2));
	}

	/* ܂Ot̕` */
	oldlps = GMPenSize(LONGWORD(2, 2));
	for (i = 0; i < 7; i++) {
		GMForeColor(gColor[i]);
		pt.p.x = LINESTX + 30;
		for (j = 0; j < 4; j++) {
			pt.p.y = LINESTY - (dot * pcv->money[mon[j] - 1][i] + LINESCL / 2) / LINESCL;
			if (j == 0)
				GMMove(pt.x_y);
			else
				GMLine(pt.x_y);
			pt.p.x += 75;
		}
	}
	GMPenSize(oldlps);

	/* `摮ftHg̒lɖ߂ */
	GMPenMode(oldpm);
	GMForeColor(oldfc);
	GMFontMode(oldfm);
}
